/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.UiException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.UploadEvent;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Doublebox;
import org.zkoss.zul.Image;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.api.Timebox;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Colonia;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.FormaPago;
import com.rjconsultores.ventaboletos.entidad.FormaPagoDet;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Nodo;
import com.rjconsultores.ventaboletos.entidad.ParamRecoleccion;
import com.rjconsultores.ventaboletos.entidad.PtoVtaUsuarioBancario;
import com.rjconsultores.ventaboletos.entidad.PtovtaAgencia;
import com.rjconsultores.ventaboletos.entidad.PtovtaAntecipacomissao;
import com.rjconsultores.ventaboletos.entidad.InstiFinanceira;
import com.rjconsultores.ventaboletos.entidad.PtovtaComissao;
import com.rjconsultores.ventaboletos.entidad.PtovtaDiversos;
import com.rjconsultores.ventaboletos.entidad.PtovtaEmpresa;
import com.rjconsultores.ventaboletos.entidad.PtovtaEstoque;
import com.rjconsultores.ventaboletos.entidad.PtovtaHorario;
import com.rjconsultores.ventaboletos.entidad.PtovtaTitular;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.UsuarioBancario;
import com.rjconsultores.ventaboletos.service.CiudadService;
import com.rjconsultores.ventaboletos.service.ColoniaService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.FormaPagoService;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.service.NodoService;
import com.rjconsultores.ventaboletos.service.PtoVtaUsuarioBancarioService;
import com.rjconsultores.ventaboletos.service.InstiFinanceiraService;
import com.rjconsultores.ventaboletos.service.PtovtaEmpresaService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.service.UsuarioBancarioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import com.rjconsultores.ventaboletos.web.utilerias.render.FormaPagoDetRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.ParamRecoleccionRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaAntecipacomissaoRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaEmpresaRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaEstoqueRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaHorarioRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaUsuarioBancarioRender;

/**
 * 
 * @author Rafius
 */
@Controller("editarPuntoVentaController")
@Scope("prototype")
public class EditarPuntoVentaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private PuntoVentaService puntoVentaService;
	@Autowired
	private EmpresaService empresaService;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private MonedaService monedaService;
	@Autowired
	private InstiFinanceiraService ptovtaBancoService;
	@Autowired
	private NodoService nodoService;
	@Autowired
	private FormaPagoService formaPagoService;
	@Autowired
	private CiudadService ciudadService;
	@Autowired
	private ColoniaService coloniaService;
	@Autowired
	private PtovtaEmpresaService ptovtaEmpresaService;
	@Autowired
	private PtoVtaUsuarioBancarioService ptoVtaUsuarioBancarioService;
	@Autowired
	private UsuarioBancarioService usuarioBancarioService;
	private PuntoVenta puntoVenta;
	private Textbox txtCP;
	private MyListbox puntoVentaList;
	private MyListbox paramRecoleccionList;
	private MyListbox formaPagoList;
	private MyListbox ptovtaEmpresaList;
	private MyListbox ptovtaUsuarioBancarioList;
	private MyListbox ptovtaAntecipaList;
	private MyListbox ptovtaHorarioList;
	private MyListbox ptovtaEstoqueList;
	private static Logger log = Logger.getLogger(EditarPuntoVentaController.class);
	private List<Empresa> lsEmpresas;
	private List<InstiFinanceira> lsBanco;
	private List<TipoPuntoVenta> lsTipoPuntoVenta;
	private List<Moneda> lsMoneda;
	private List<Colonia> lsColonia;
	private List<Nodo> lsNodos;
	private List<FormaPago> lsFormaPago;
	private List<FormaPagoDet> lsFormaPagoDet;
	private List<ParamRecoleccion> lsParamRecoleccion;
	private List<UsuarioBancario> lsUsuarioBancario;
	private List<PtovtaEmpresa> lsPtovtaEmpresa;
	private List<PtoVtaUsuarioBancario> lsPtovtaUsuarioBancario;
	private List<PtovtaAntecipacomissao> lsAntecipacomissao;
	private List<PtovtaHorario> lsHorario;
	private List<PtovtaEstoque> lsEstoque;
	

	
	private Radio radDatosTarjetaSi;
	private Radio radDatosTarjetaNo;
	private Radio radAprobacionAutorizado;
	private Radio radAprobacionLatente;
	private Combobox cmbFormaPago;
	private Combobox cmbEmpresa;
	private Combobox cmbEmpresaPtoVta;
	private Combobox cmbEmpresaPtoVtaUsuarioBancario;
	private Combobox cmbParada;
	private Combobox cmbTipoPontoVenta;
	private Combobox cmbMoneda;
	private Combobox cmbNodo;
	private Combobox cmbBanco;
	private Combobox cmbPessoa;
	private Combobox cmbTipoConta;
	private Combobox cmbForm;
	private Combobox cmbLote;
	private Combobox cmbCiudad;
	private Combobox cmbColonia;
	private Combobox cmbConexion;
	private Combobox cmbUsuarioBancario;
	private Combobox cmbUsuarioBancarioPtoVtaUsuarioBancario;
	private Combobox cmbPosicao;
	private Combobox  cmbReceita;
	private Button btnSalvarFormaPago;
	private Button btnApagar;
	private Doublebox txtCargosExtras;
	private MyTextbox txtNome;
	private MyTextbox txtNumFax;
	private MyTextbox txtCompl;
	private MyTextbox txtNumAg;
	private MyTextbox txtConta;
	private MyTextbox txtDigito;
	private MyTextbox txtBilhetes;
	private MyTextbox txtCarga; 
	private MyTextbox txtEspecie;
	private MyTextbox txtTitularNome;
	private MyTextbox txtTitularCpf;
	private MyTextbox txtTitularRg;
	private MyTextbox txtTitularEmissor;
	private MyTextbox txtResponAluguel;
	private MyTextbox txtResponTel;
	private MyTextbox txtResponEnergia;
	private MyTextboxDecimal importeInicial;
	private MyTextboxDecimal importeAdicional; 
	private Datebox dateAntecipData;
	private MyTextboxDecimal txtAntecipRetem;
	private MyTextboxDecimal txtAntecipPercentual;
	private MyTextboxDecimal txtPassagemBaixa;
	private MyTextboxDecimal txtPassagemAlta;
	private MyTextboxDecimal txtExcessoBaixa;
	private MyTextboxDecimal txtExcessoAlta;
	private MyTextboxDecimal txtSeguroBaixa;
	private MyTextboxDecimal txtSeguroAlta;
	private MyTextboxDecimal txtOutrosBaixa;
	private MyTextboxDecimal txtOutrosAlta;
	private MyTextboxDecimal txtIss;
	private MyTextboxDecimal txtRoyaties;
	private Image img;
	private Timebox timeboxInicio;
	private Timebox timeboxFim;
	private Intbox txtQuant;
	private Intbox txtcodAg;
	private Textbox  txtNomeBanco;
	private Checkbox  checkRecibo;
	private Checkbox checkTarifaReceita;
	private Checkbox checkTaxaReceita;
	private Checkbox checkSeguroReceita;
	private Checkbox checkPedagioReceita;
	private Checkbox checkTarifaDev;
	private Checkbox checkTaxaDev;
	private Checkbox checkSeguroDev;
	private Checkbox checkPedagioDev;
	private Checkbox checkInformatizada;
	private Checkbox checkBilheteInfo;
	private Checkbox checkVendaInternet;
	private Checkbox checkTeleEntrega;
	private Checkbox checkDigitacao;
	private Checkbox checkBilhete;
	private Checkbox checkOfpsPropria;
	private Checkbox checkOfpsTerceiros;


	

	

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}
	
	 
	 
	

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		
		super.doAfterCompose(comp);
		
		popularCombobox(cmbPessoa, this.getPessoa());
		popularCombobox(cmbTipoConta, this.getTipoConta());
		popularCombobox(cmbForm, this.getForm());
		popularCombobox(cmbLote, this.getLote());
		popularCombobox(cmbReceita, this.getTipoConta());
		
		lsEmpresas = empresaService.obtenerIndTipo1();
		lsMoneda = monedaService.obtenerTodos();
		lsBanco = ptovtaBancoService.obtenerTodos();
		lsColonia = new ArrayList<Colonia>();
		lsNodos = nodoService.obtenerTodos();
		lsFormaPago = formaPagoService.obtenerTodos();
		lsTipoPuntoVenta = tipoPuntoVentaService.obtenerTodos();
		lsUsuarioBancario = usuarioBancarioService.obtenerTodos();
		
		
		
		
		try {
			txtCP.setDisabled(true);
			puntoVenta = (PuntoVenta) Executions.getCurrent().getArg().get("puntoVenta");
			
			if (puntoVenta.getPuntoventaId() != null) {
				puntoVenta = puntoVentaService.obtenerID(puntoVenta.getPuntoventaId());
				if (puntoVenta.getColonia() != null) {
					cmbCiudad.setText(puntoVenta.getColonia().getCiudad().getNombciudad());
					cmbColonia.setText(puntoVenta.getColonia().getDesccolonia());
				}
			}

			puntoVentaList = (MyListbox) Executions.getCurrent().getArg().get("puntoVentaList");

			if (puntoVenta.getPuntoventaId() != null) {
				if (puntoVenta.getStatusaprobacion() != null) {
					if (puntoVenta.getStatusaprobacion().equals("A")) {
						radAprobacionAutorizado.setChecked(true);
					} else if (puntoVenta.getStatusaprobacion().equals("L")) {
						radAprobacionLatente.setChecked(true);
					}
				}
			}
			
			
			if (puntoVenta.getPuntoventaId() != null) {
				if (puntoVenta.getComissaoId()!= null) {
					if(puntoVenta.getComissaoId().getReceita() != null){
						cmbReceita.setText(puntoVenta.getComissaoId().getReceita());
					}
					
					if(puntoVenta.getComissaoId().getTarifaDev()!= null){
						if(puntoVenta.getComissaoId().getTarifaDev()){
							checkTarifaDev.setChecked(true);
						}else{
							checkTarifaDev.setChecked(false);
						}
					}
					
					if(puntoVenta.getComissaoId().getTaxaDev() != null){
						if(puntoVenta.getComissaoId().getTaxaDev()){
							checkTaxaDev.setChecked(true);
						}else{
							checkTaxaDev.setChecked(false);
						}
					}
					
					if(puntoVenta.getComissaoId().getPegagioDev() != null){
						if(puntoVenta.getComissaoId().getPegagioDev()){
							checkPedagioDev.setChecked(true);
						}else{
							checkPedagioDev.setChecked(false);
						}
						
						
					}
					
					if(puntoVenta.getComissaoId().getSeguroDev()!= null){
						if(puntoVenta.getComissaoId().getSeguroDev()){
							checkSeguroDev.setChecked(true);
						}else{
							checkSeguroDev.setChecked(false);
						}
					}
					
					if(puntoVenta.getComissaoId().getTarifaReceita()!= null){
						if(puntoVenta.getComissaoId().getTarifaReceita()){
							checkTarifaReceita.setChecked(true);
						}else{
							checkTarifaReceita.setChecked(false);
						}
					}
					
					if(puntoVenta.getComissaoId().getTaxaReceita() != null){
						if(puntoVenta.getComissaoId().getTaxaReceita()){
							checkTaxaReceita.setChecked(true);
						}else{
							checkTaxaReceita.setChecked(false);
						}
					}
					
					if(puntoVenta.getComissaoId().getPedagioReceita() != null){
						if(puntoVenta.getComissaoId().getPedagioReceita()){
							checkPedagioReceita.setChecked(true);
						}else{
							checkPedagioReceita.setChecked(false);
						}
					}
					
					if(puntoVenta.getComissaoId().getSeguroReceita()!= null){
						if(puntoVenta.getComissaoId().getSeguroReceita()){
							checkSeguroReceita.setChecked(true);
						}else{
							checkSeguroReceita.setChecked(false);
						}
					}
				}else{
					puntoVenta.setComissaoId(new PtovtaComissao());
				}
			}
			
			if (puntoVenta.getPuntoventaId() != null) {
				if (puntoVenta.getAgenciaId()!= null) {
					
					if(puntoVenta.getAgenciaId().getInstiFinanceiraId()!= null){
						cmbBanco.setText(puntoVenta.getAgenciaId().getInstiFinanceiraId().getCodigo());
						txtNomeBanco.setText(puntoVenta.getAgenciaId().getInstiFinanceiraId().getNome());
					}
					
					if(puntoVenta.getAgenciaId().getPessoa() != null){
						cmbPessoa.setText(puntoVenta.getAgenciaId().getPessoa());
					}
					
					if(puntoVenta.getAgenciaId().getTipo() != null){
						cmbTipoConta.setText(puntoVenta.getAgenciaId().getTipo());
					}
					
				}else{
					puntoVenta.setAgenciaId(new PtovtaAgencia());
				}
			}
			
			if (puntoVenta.getPuntoventaId() != null) {
				if (puntoVenta.getDiversosId()!= null) {
					if(puntoVenta.getDiversosId().getInformatizada()!= null){
						if(puntoVenta.getDiversosId().getInformatizada()){
							checkInformatizada.setChecked(true);
						}else{
							checkInformatizada.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getBilheteInfo()!= null){
						if(puntoVenta.getDiversosId().getBilheteInfo()){
							checkBilheteInfo.setChecked(true);
						}else{
							checkBilheteInfo.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getVendaInternet()!= null){
						if(puntoVenta.getDiversosId().getVendaInternet()){
							checkVendaInternet.setChecked(true);
						}else{
							checkVendaInternet.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getTeleEntrega()!= null){
						if(puntoVenta.getDiversosId().getTeleEntrega()){
							checkTeleEntrega.setChecked(true);
						}else{
							checkTeleEntrega.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getDigitacaoSeq()!= null){
						if(puntoVenta.getDiversosId().getDigitacaoSeq()){
							checkDigitacao.setChecked(true);
						}else{
							checkDigitacao.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getTrabalhaBilhete()!= null){
						if(puntoVenta.getDiversosId().getTrabalhaBilhete()){
							checkBilhete.setChecked(true);
						}else{
							checkBilhete.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getOfpsPropria()!= null){
						if(puntoVenta.getDiversosId().getOfpsPropria()){
							checkOfpsPropria.setChecked(true);
						}else{
							checkOfpsPropria.setChecked(false);
						}
					}
					
					if(puntoVenta.getDiversosId().getOfpsTerceiros()!= null){
						if(puntoVenta.getDiversosId().getOfpsTerceiros()){
							checkOfpsTerceiros.setChecked(true);
						}else{
							checkOfpsTerceiros.setChecked(false);
						}
					}
					
				}else{
					puntoVenta.setDiversosId(new PtovtaDiversos());
				}
			}
			
			
			if (puntoVenta.getPuntoventaId() != null) {
				if(puntoVenta.getTitularId() != null){
					if (puntoVenta.getTitularId().getImagem() != null) {
						img.setContent(new org.zkoss.image.AImage("imagem",
								puntoVenta.getTitularId().getImagem() ));
					}
				}else{
					puntoVenta.setTitularId(new PtovtaTitular());
				}
			}
			
			

			formaPagoList.setItemRenderer(new FormaPagoDetRender());
			if (puntoVenta.getLsFormaPagoDet() == null) {
				puntoVenta.setLsFormaPagoDet(new ArrayList<FormaPagoDet>());
			}
			lsFormaPagoDet = puntoVenta.getLsFormaPagoDet();
			formaPagoList.setData(lsFormaPagoDet);

			paramRecoleccionList.setItemRenderer(new ParamRecoleccionRender());
			if (puntoVenta.getLsParamRecoleccion() == null) {
				puntoVenta.setLsParamRecoleccion(new ArrayList<ParamRecoleccion>());
			}

			lsParamRecoleccion = puntoVenta.getLsParamRecoleccion();
			paramRecoleccionList.setData(lsParamRecoleccion);

			ptovtaEmpresaList.setItemRenderer(new PtovtaEmpresaRender());
			
			
			if (puntoVenta.getLsPtovtaEmpresa() == null) {
				puntoVenta.setLsPtovtaEmpresa(new ArrayList<PtovtaEmpresa>());
			}
			
			lsPtovtaEmpresa = puntoVenta.getLsPtovtaEmpresa();
			ptovtaEmpresaList.setData(lsPtovtaEmpresa);
			
			
			ptovtaAntecipaList.setItemRenderer(new PtovtaAntecipacomissaoRender());
			if(puntoVenta.getPtovtaAntecipacomissaoList() == null){
				puntoVenta.setPtovtaAntecipacomissaoList(new ArrayList<PtovtaAntecipacomissao>());
			}
			
			lsAntecipacomissao = puntoVenta.getPtovtaAntecipacomissaoList();
			ptovtaAntecipaList.setData(lsAntecipacomissao);
			
			ptovtaHorarioList.setItemRenderer(new PtovtaHorarioRender());
			if(puntoVenta.getPtovtaHorarioList() == null){
				puntoVenta.setPtovtaHorarioList(new ArrayList<PtovtaHorario>());
			}
			
			lsHorario = puntoVenta.getPtovtaHorarioList();
			ptovtaHorarioList.setData(lsHorario);
			
			ptovtaEstoqueList.setItemRenderer(new PtovtaEstoqueRender());
			if(puntoVenta.getPtovtaEstoqueList() == null){
				puntoVenta.setPtovtaEstoqueList(new ArrayList<PtovtaEstoque>());
			}
			
			lsEstoque = puntoVenta.getPtovtaEstoqueList();
			ptovtaEstoqueList.setData(lsEstoque);

			ptovtaUsuarioBancarioList.setItemRenderer(new PtovtaUsuarioBancarioRender());
			if (puntoVenta.getLsPtovtaUsuarioBancario() == null) {
				puntoVenta.setLsPtovtaUsuarioBancario(new ArrayList<PtoVtaUsuarioBancario>());
			}

			lsPtovtaUsuarioBancario = puntoVenta.getLsPtovtaUsuarioBancario();
			ptovtaUsuarioBancarioList.setData(lsPtovtaUsuarioBancario);

			if (puntoVenta.getPuntoventaId() == null) {
				btnApagar.setVisible(Boolean.FALSE);
			} else {
				if (puntoVenta.getParada() != null) {
					cmbParada.setText(puntoVenta.getParada().getDescparada());
				}
			}
		} catch (Exception e) {
			log.error("Punto de Venta: " + e);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
		txtNome.focus();
	}
	
	public void clearCombobox(Combobox combobox) {
		
		int size = combobox.getItemCount();
		
		for (int i = size - 1; i >= 0; i--){
			combobox.removeItemAt(i);
		}
	}
	
	
	public void popularCombobox(Combobox cmb, List<String> lista) throws Exception{
		
		clearCombobox(cmb);
		
		List<String> getList = lista;
		
		if(!getList.isEmpty()){
			
			for (String obj : getList) {
				
				Comboitem comboItem = new Comboitem(obj);				
				comboItem.setValue(obj);
				comboItem.setParent(cmb);
				
			}
			
		}	
		
	}
	
	public void onSelect$cmbBanco(){
		InstiFinanceira banco = (InstiFinanceira) cmbBanco.getSelectedItem().getValue();
		txtNomeBanco.setValue(banco.getNome());
		
	}

	public void onChange$cmbCiudad(Event ev) {
		if (cmbCiudad.getSelectedItem() == null) {
			return;
		} else {
			cmbColonia.setSelectedItem(null);
			Ciudad c = (Ciudad) cmbCiudad.getSelectedItem().getValue();
			List<Colonia> lsCol = coloniaService.buscarPorCiudad(c);
			BindingListModel dictModel = new BindingListModelList(lsCol, false);
			cmbColonia.setModel(dictModel);
		}
	}

	public void onChange$cmbColonia(Event ev) {
		if (cmbColonia.getSelectedItem() == null) {
			return;
		} else {
			Colonia col = (Colonia) cmbColonia.getSelectedItem().getValue();
			txtCP.setValue(col.getCodpostal());
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		
		txtNome.getValue();
		txtNumFax.getValue();
		txtCompl.getValue();
		txtNumAg.getValue();
		txtConta.getValue();
		txtDigito.getValue();
		txtBilhetes.getValue();
		txtCarga.getValue();
		txtTitularNome.getValue();
		txtTitularCpf.getValue();
		txtTitularRg.getValue();
		txtTitularEmissor.getValue();
		txtAntecipRetem.getValue();
		txtAntecipPercentual.getValue();
		txtPassagemBaixa.getValue();
		txtPassagemAlta.getValue();
		txtExcessoBaixa.getValue();
		txtExcessoAlta.getValue();
		txtSeguroBaixa.getValue();
		txtSeguroAlta.getValue();
		txtOutrosBaixa.getValue();
		txtOutrosAlta.getValue();
		txtIss.getValue();
		txtRoyaties.getValue();
		txtcodAg.getValue();
		txtResponAluguel.getValue();
		txtResponTel.getValue();
		txtResponEnergia.getValue();

		cmbEmpresa.getValue();
		cmbParada.getValue();
		cmbTipoPontoVenta.getValue();
		cmbMoneda.getValue();
		cmbNodo.getValue();
		cmbColonia.setConstraint("no empty");
		cmbColonia.getValue();
		cmbCiudad.getValue();
		cmbBanco.getValue();
		cmbPessoa.getValue();
		cmbTipoConta.getValue();
		cmbPosicao.getValue();
		
		
		try {
			if (puntoVenta.getEmpresa() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.empresa"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (puntoVenta.getTipoPuntoVenta() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.punto"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (puntoVenta.getMoneda() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.moneda"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (puntoVenta.getNodo() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.nodo"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (lsFormaPagoDet.isEmpty()) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.formaDePago"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else {

				if (cmbConexion.getValue().equals("")) {
					puntoVenta.setConexionBancaria(null);
					puntoVenta.setUsuarioBancario(null);
				}

				if (cmbUsuarioBancario.getValue() == null) {
					puntoVenta.setUsuarioBancario(null);
				}

				List<PuntoVenta> lsPv = puntoVentaService.buscar(puntoVenta);

				boolean podeSalvar = false;

				if (lsPv.isEmpty()) {
					podeSalvar = true;
				}
				for (PuntoVenta pv : lsPv) {
					if (pv.getPuntoventaId().equals(puntoVenta.getPuntoventaId())) {
						podeSalvar = true;
					}
				}

				if (podeSalvar) {
					if (cmbColonia.getSelectedItem() != null) {
						puntoVenta.setColonia((Colonia) cmbColonia.getSelectedItem().getValue());
					}
					puntoVenta.setActivo(Boolean.TRUE);
					puntoVenta.setFecmodif(Calendar.getInstance().getTime());
					puntoVenta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
					puntoVenta.setLsFormaPagoDet(lsFormaPagoDet);
					puntoVenta.setLsParamRecoleccion(lsParamRecoleccion);
					puntoVenta.setLsPtovtaEmpresa(lsPtovtaEmpresa);
					puntoVenta.setLsPtovtaUsuarioBancario(lsPtovtaUsuarioBancario);
					puntoVenta.setPtovtaAntecipacomissaoList(lsAntecipacomissao);
					puntoVenta.setPtovtaHorarioList(lsHorario);
					puntoVenta.setPtovtaEstoqueList(lsEstoque);
					
					
					
					if(cmbBanco.getSelectedItem()== null){
						puntoVenta.setAgenciaId(null);
					}else{
						puntoVenta.getAgenciaId().setInstiFinanceiraId((InstiFinanceira) cmbBanco.getSelectedItem().getValue());
						if (cmbPessoa.getSelectedItem() != null){ 
							puntoVenta.getAgenciaId().setPessoa((String) cmbPessoa.getSelectedItem().getValue());
						}
						
						if (cmbTipoConta.getSelectedItem() != null){
							puntoVenta.getAgenciaId().setTipo((String) cmbTipoConta.getSelectedItem().getValue());
						}
						puntoVenta.getAgenciaId().setActivo(Boolean.TRUE);
						puntoVenta.getAgenciaId().setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
						puntoVenta.getAgenciaId().setFecmodif(Calendar.getInstance().getTime());
					}
					
					if(txtTitularCpf.getValue().equals("")){
						puntoVenta.setTitularId(null);
					}else{
						puntoVenta.getTitularId().setActivo(Boolean.TRUE);
						puntoVenta.getTitularId().setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
						puntoVenta.getTitularId().setFecmodif(Calendar.getInstance().getTime());
					}
					
					if((txtIss.getValue().equals(""))&&(txtRoyaties.getValue().equals("")) && (txtExcessoAlta.getValue().equals(""))
							&&(txtExcessoBaixa.getValue().equals(""))&&(txtPassagemBaixa.getValue().equals(""))
							&&(txtPassagemAlta.getValue().equals(""))&&(txtSeguroBaixa.getValue().equals("")) ){
						puntoVenta.setComissaoId(null);
					}else{
						puntoVenta.getComissaoId().setEnviarrecibo(checkRecibo.isChecked());
						puntoVenta.getComissaoId().setTarifaReceita(checkTarifaReceita.isChecked());
						puntoVenta.getComissaoId().setTaxaReceita(checkTaxaReceita.isChecked());
						puntoVenta.getComissaoId().setSeguroReceita(checkSeguroReceita.isChecked());
						puntoVenta.getComissaoId().setPedagioReceita(checkPedagioReceita.isChecked());
						puntoVenta.getComissaoId().setTarifaDev(checkTarifaDev.isChecked());
						puntoVenta.getComissaoId().setTaxaDev(checkTaxaDev.isChecked());
						puntoVenta.getComissaoId().setSeguroDev(checkSeguroDev.isChecked());
						puntoVenta.getComissaoId().setPegagioDev(checkPedagioDev.isChecked());
						puntoVenta.getComissaoId().setActivo(Boolean.TRUE);
						puntoVenta.getComissaoId().setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
						puntoVenta.getComissaoId().setFecmodif(Calendar.getInstance().getTime());
					}
					
					if((txtResponAluguel.getValue().equals("")&&(txtResponTel.getValue().equals("")))){
						puntoVenta.setDiversosId(null);
					}else{
						puntoVenta.getDiversosId().setBilheteInfo(checkBilheteInfo.isChecked());
						puntoVenta.getDiversosId().setInformatizada(checkInformatizada.isChecked());
						puntoVenta.getDiversosId().setVendaInternet(checkVendaInternet.isChecked());
						puntoVenta.getDiversosId().setTeleEntrega(checkTeleEntrega.isChecked());
						puntoVenta.getDiversosId().setDigitacaoSeq(checkDigitacao.isChecked());
						puntoVenta.getDiversosId().setTrabalhaBilhete(checkBilhete.isChecked());
						puntoVenta.getDiversosId().setOfpsPropria(checkOfpsPropria.isChecked());
						puntoVenta.getDiversosId().setOfpsTerceiros(checkOfpsTerceiros.isChecked());
						puntoVenta.getDiversosId().setActivo(Boolean.TRUE);
						puntoVenta.getDiversosId().setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
						puntoVenta.getDiversosId().setFecmodif(Calendar.getInstance().getTime());
					}
					
					
					

					List<PtovtaEmpresa> lsPto = new ArrayList<PtovtaEmpresa>();
					for (PtovtaEmpresa pto : lsPtovtaEmpresa) {
						if (!pto.getActivo()) {
							ptovtaEmpresaService.borrarFisico(pto);
						} else {
							pto.setPuntoVenta(puntoVenta);
							lsPto.add(pto);
						}
					}
					puntoVenta.setLsPtovtaEmpresa(lsPto);

					List<PtoVtaUsuarioBancario> lsPto2 = new ArrayList<PtoVtaUsuarioBancario>();
					for (PtoVtaUsuarioBancario pto2 : lsPtovtaUsuarioBancario) {
						if (!pto2.getActivo()) {
							ptoVtaUsuarioBancarioService.borrarFisico(pto2);
						} else {
							pto2.setPuntoVenta(puntoVenta);
							lsPto2.add(pto2);
						}
					}
					puntoVenta.setLsPtovtaUsuarioBancario(lsPto2);

					if (radAprobacionAutorizado.isChecked()) {
						puntoVenta.setStatusaprobacion("A");
					} else if (radAprobacionLatente.isChecked()) {
						puntoVenta.setStatusaprobacion("L");
					}

					if (puntoVenta.getPuntoventaId() == null) {
						puntoVentaService.suscribir(puntoVenta);
						puntoVentaList.addItem(puntoVenta);
					} else {
						puntoVentaService.actualizacion(puntoVenta);
						puntoVentaList.updateItem(puntoVenta);
					}

					Messagebox.show(
							Labels.getLabel("editarPuntoVentaController.MSG.suscribirOK"),
							Labels.getLabel("editarPuntoVentaController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);

					closeWindow();
				} else {
					Messagebox.show(
							Labels.getLabel("MSG.Registro.Existe"),
							Labels.getLabel("editarPuntoVentaController.window.title"),
							Messagebox.OK, Messagebox.EXCLAMATION);
				}
			}
		} catch (Exception ex) {
			log.error("editarPuntoVentaController: ", ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarPuntoVentaController.MSG.borrarPergunta"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				puntoVentaService.borrar(puntoVenta);

				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.borrarOK"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				puntoVentaList.removeItem(puntoVenta);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
	
	
	public void uploadPhoto(UploadEvent event) {
		org.zkoss.util.media.Media media = event.getMedia();

		try {
			if (media instanceof org.zkoss.image.Image) {
				img.setContent(new org.zkoss.image.AImage(media.getName(),
						media.getStreamData()));
			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.errorIMG") + " " + media,
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.ERROR);
			}
		} catch (IOException ex) {
			log.error(ex);
			throw UiException.Aide.wrap(ex);
		} catch (InterruptedException ex) {
			log.error(ex);
			throw UiException.Aide.wrap(ex);
		}
	}

	
	public void onClick$btnSalvarAntecipa()throws InterruptedException{
		dateAntecipData.getValue();
		txtAntecipRetem.getValue();
		txtAntecipPercentual.getValue();
		try {
			PtovtaAntecipacomissao antecipa = new PtovtaAntecipacomissao();
			
				
			antecipa.setData(dateAntecipData.getValue());
			antecipa.setPercentual(txtAntecipPercentual.getValueDecimal());
			antecipa.setRetem(txtAntecipRetem.getValueDecimal());
			antecipa.setPuntoventaId(puntoVenta);

			antecipa.setActivo(Boolean.TRUE);
			antecipa.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			antecipa.setFecmodif(Calendar.getInstance().getTime());

			lsAntecipacomissao.add(antecipa);
			ptovtaAntecipaList.setData(lsAntecipacomissao);
					
				
			
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}
	
	
	public void onClick$btnApagarAntecipa() {
		try {
			PtovtaAntecipacomissao antecipa = (PtovtaAntecipacomissao) ptovtaAntecipaList.getSelected();
			if (antecipa != null) {
				antecipa.setActivo(Boolean.FALSE);
				antecipa.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				antecipa.setFecmodif(Calendar.getInstance().getTime());

				ptovtaAntecipaList.removeItem(antecipa);
				lsAntecipacomissao.remove(antecipa);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
	
	
	public void onClick$btnSalvarHorario()throws InterruptedException{
		timeboxInicio.getValue();
		timeboxFim.getValue();
		try {
			PtovtaHorario horario = new PtovtaHorario();
		
				
					
			horario.setInicio(timeboxInicio.getValue());
			horario.setFim(timeboxFim.getValue());
			horario.setPuntoventaId(puntoVenta);
			horario.setActivo(Boolean.TRUE);
			horario.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			horario.setFecmodif(Calendar.getInstance().getTime());

			lsHorario.add(horario);
			ptovtaHorarioList.setData(lsHorario);
					
				
			
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}
	
	public void onClick$btnApagarHorario() {
		try {
			PtovtaHorario horario = (PtovtaHorario) ptovtaHorarioList.getSelected();
			if (horario != null) {
				horario.setActivo(Boolean.FALSE);
				horario.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				horario.setFecmodif(Calendar.getInstance().getTime());

				ptovtaHorarioList.removeItem(horario);
				lsHorario.remove(horario);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
	
	
	public void onClick$btnSalvarEstoque()throws InterruptedException{
		txtEspecie.getValue();
		cmbForm.getValue();
		txtQuant.getValue();
		cmbLote.getValue();
		try {
			PtovtaEstoque estoque = new PtovtaEstoque();
			
				
			estoque.setEspecie(txtEspecie.getValue());
			estoque.setFormCont((String) cmbForm.getSelectedItem().getValue());
			estoque.setLoteform((String)cmbLote.getSelectedItem().getValue());
			estoque.setQuantidade(txtQuant.getValue());
			estoque.setPuntoventaId(puntoVenta);

			estoque.setActivo(Boolean.TRUE);
			estoque.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			estoque.setFecmodif(Calendar.getInstance().getTime());

			lsEstoque.add(estoque);
			ptovtaEstoqueList.setData(lsEstoque);
					
				
			
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}
	
	public void onClick$btnApagarEstoque() {
		try {
			PtovtaEstoque estoque = (PtovtaEstoque) ptovtaEstoqueList.getSelected();
			if (estoque != null) {
				estoque.setActivo(Boolean.FALSE);
				estoque.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				estoque.setFecmodif(Calendar.getInstance().getTime());

				ptovtaEstoqueList.removeItem(estoque);
				lsEstoque.remove(estoque);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onClick$btnSalvarFormaPago(Event ev) throws InterruptedException {
		cmbFormaPago.getValue();
		txtCargosExtras.getValue();
		try {
			FormaPago formaPago = new FormaPago();
			try {
				formaPago = (FormaPago) cmbFormaPago.getSelectedItem().getValue();
				Boolean achou = Boolean.FALSE;
				if (formaPago != null) {
					for (FormaPagoDet fpd : lsFormaPagoDet) {
						if (fpd.getFormaPago().getFormapagoId().equals(formaPago.getFormapagoId())) {
							achou = Boolean.TRUE;
						}
					}
					if (!achou) {
						FormaPagoDet fpd = new FormaPagoDet();
						fpd.setCargosextras(new BigDecimal(txtCargosExtras.getValue()));
						fpd.setFormaPago(formaPago);
						fpd.setPuntoVenta(puntoVenta);

						fpd.setActivo(Boolean.TRUE);
						fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
						fpd.setFecmodif(Calendar.getInstance().getTime());

						lsFormaPagoDet.add(fpd);
						formaPagoList.setData(lsFormaPagoDet);
					} else {
						Messagebox.show(
								Labels.getLabel("editarPuntoVentaController.MSG.Achou.FormaPago"),
								Labels.getLabel("editarPuntoVentaController.window.title"),
								Messagebox.OK, Messagebox.EXCLAMATION);
					}
				}
			} catch (Exception e) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.formaDePago"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarFormaPago(Event ev) {
		try {
			FormaPagoDet fpd = (FormaPagoDet) formaPagoList.getSelected();
			if (fpd != null) {
				fpd.setActivo(Boolean.FALSE);
				fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				fpd.setFecmodif(Calendar.getInstance().getTime());

				formaPagoList.removeItem(fpd);
				lsFormaPagoDet.remove(fpd);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onClick$btnSalvarParamRecoleccion(Event ev) throws InterruptedException {
		importeInicial.getValue();
		importeAdicional.getValue();
		try {
			ParamRecoleccion paramRecoleccion = new ParamRecoleccion();
			paramRecoleccion.setImporteinicial(importeInicial.getValueDecimal());
			paramRecoleccion.setImporteadicional(importeAdicional.getValueDecimal());

			Boolean achou = Boolean.FALSE;

			for (ParamRecoleccion fpd : lsParamRecoleccion) {
				if (fpd.getImporteinicial().equals(paramRecoleccion.getImporteinicial())) {
					achou = Boolean.TRUE;
				}
			}
			if (!achou) {

				paramRecoleccion.setPuntoVenta(puntoVenta);
				paramRecoleccion.setActivo(Boolean.TRUE);
				paramRecoleccion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				paramRecoleccion.setFecmodif(Calendar.getInstance().getTime());

				lsParamRecoleccion.add(paramRecoleccion);
				paramRecoleccionList.setData(lsParamRecoleccion);
			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.Achou.ParamRecoleccion"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}

		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarParamRecoleccion(Event ev) {
		try {
			ParamRecoleccion fpd = (ParamRecoleccion) paramRecoleccionList.getSelected();
			if (fpd != null) {
				fpd.setActivo(Boolean.FALSE);
				fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				fpd.setFecmodif(Calendar.getInstance().getTime());

				paramRecoleccionList.removeItem(fpd);
				lsParamRecoleccion.remove(fpd);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onClick$btnSalvarPtovtaEmpresa(Event ev) throws InterruptedException {
		cmbEmpresaPtoVta.getValue();
		try {
			PtovtaEmpresa ptovtaEmpresa = new PtovtaEmpresa();

			Boolean achou = Boolean.FALSE;

			ptovtaEmpresa.setEmpresa((Empresa) cmbEmpresaPtoVta.getSelectedItem().getValue());

			for (PtovtaEmpresa fpd : lsPtovtaEmpresa) {
				if (fpd.getEmpresa().equals(ptovtaEmpresa.getEmpresa())
						&& fpd.getActivo()) {
					achou = Boolean.TRUE;
				}
			}
			if (!achou) {

				ptovtaEmpresa.setPuntoVenta(puntoVenta);
				ptovtaEmpresa.setActivo(Boolean.TRUE);
				ptovtaEmpresa.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				ptovtaEmpresa.setFecmodif(Calendar.getInstance().getTime());

				lsPtovtaEmpresa.add(ptovtaEmpresa);

				List<PtovtaEmpresa> lsP = new ArrayList<PtovtaEmpresa>();
				for (PtovtaEmpresa p : lsPtovtaEmpresa) {
					if (p.getActivo()) {
						lsP.add(p);
					}
				}
				ptovtaEmpresaList.setData(lsP);
				// ptovtaEmpresaList.addItem(ptovtaEmpresa);
			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.Achou.PtovtaEmpresa"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}

		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarPtovtaEmpresa(Event ev) {
		try {
			PtovtaEmpresa fpd = (PtovtaEmpresa) ptovtaEmpresaList.getSelected();
			if (fpd != null) {
				lsPtovtaEmpresa.remove(fpd);
				ptovtaEmpresaList.removeItem(fpd);
				if (fpd.getPtovtaempresaId() != null) {
					fpd.setActivo(Boolean.FALSE);
					fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
					fpd.setFecmodif(Calendar.getInstance().getTime());
					fpd.setPuntoVenta(puntoVenta);

					lsPtovtaEmpresa.add(fpd);
				}
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onChange$cmbConexion(Event ev) {
		habilitarCombo();
	}

	private void habilitarCombo() {
		Comboitem cbi = cmbConexion.getSelectedItem();
		if (cbi != null) {
			String valor = (String) cbi.getValue();

			if (valor.equals("S")) {
				cmbUsuarioBancario.setDisabled(Boolean.FALSE);
			}
		}
	}

	public void onClick$btnSalvarPtovtaUsuarioBancario(Event ev) throws InterruptedException {
		cmbEmpresaPtoVtaUsuarioBancario.getValue();
		cmbUsuarioBancarioPtoVtaUsuarioBancario.getValue();

		try {
			PtoVtaUsuarioBancario usuarioBancario = new PtoVtaUsuarioBancario();
			usuarioBancario.setEmpresa((Empresa) cmbEmpresaPtoVtaUsuarioBancario.getSelectedItem().getValue());
			usuarioBancario.setUsuarioBancario((UsuarioBancario) cmbUsuarioBancarioPtoVtaUsuarioBancario.getSelectedItem().getValue());

			Boolean achou = Boolean.FALSE;

			for (PtoVtaUsuarioBancario fpd : lsPtovtaUsuarioBancario) {
				if (fpd.getEmpresa().equals(usuarioBancario.getEmpresa())) {
					achou = Boolean.TRUE;
				}
			}
			if (!achou) {

				usuarioBancario.setPuntoVenta(puntoVenta);
				usuarioBancario.setActivo(Boolean.TRUE);
				usuarioBancario.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				usuarioBancario.setFecmodif(Calendar.getInstance().getTime());

				lsPtovtaUsuarioBancario.add(usuarioBancario);

				List<PtoVtaUsuarioBancario> lsP = new ArrayList<PtoVtaUsuarioBancario>();
				for (PtoVtaUsuarioBancario p : lsPtovtaUsuarioBancario) {
					if (p.getActivo()) {
						lsP.add(p);
					}
				}
				ptovtaUsuarioBancarioList.setData(lsP);
				// ptovtaEmpresaList.addItem(ptovtaEmpresa);

			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.Achou.PtovtaUsuario"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}

		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarPtovtaUsuarioBancario(Event ev) {
		try {
			PtoVtaUsuarioBancario fpd = (PtoVtaUsuarioBancario) ptovtaUsuarioBancarioList.getSelected();
			if (fpd != null) {
				ptovtaUsuarioBancarioList.removeItem(fpd);
				lsPtovtaUsuarioBancario.remove(fpd);
				if (fpd.getPtovtaUsuarioBancarioID() != null) {
					fpd.setActivo(Boolean.FALSE);
					fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
					fpd.setFecmodif(Calendar.getInstance().getTime());

					lsPtovtaUsuarioBancario.add(fpd);
				}
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
	
	public List<String> getReceita(){
		return PtovtaComissao.getReceitaList();
	}
	
	public List<String> getPessoa() {
        return PtovtaAgencia.getPessoaList();
	}
	
	public List<String> getTipoConta() {
        return PtovtaAgencia.getTipoContaList();
	}
	
	public List<String> getForm() {
        return PtovtaEstoque.getFormList();
	}
	
	public List<String> getLote() {
        return PtovtaEstoque.getLoteList();
	}

	public PuntoVenta getPuntoVenta() {
		return puntoVenta;
	}

	public void setPuntoVenta(PuntoVenta puntoVenta) {
		this.puntoVenta = puntoVenta;
	}

	public MyListbox getPuntoVentaList() {
		return puntoVentaList;
	}

	
	public MyListbox getAntecipaList() {
		return ptovtaAntecipaList;
	}

	public void setAntecipaList(MyListbox antecipaList) {
		this.ptovtaAntecipaList = antecipaList;
	}

	public void setPuntoVentaList(MyListbox puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	public PuntoVentaService getPuntoVentaService() {
		return puntoVentaService;
	}

	public void setPuntoVentaService(PuntoVentaService puntoVentaService) {
		this.puntoVentaService = puntoVentaService;
	}

	public EmpresaService getEmpresaService() {
		return empresaService;
	}

	public void setEmpresaService(EmpresaService empresaService) {
		this.empresaService = empresaService;
	}

	public TipoPuntoVentaService getTipoPuntoVentaService() {
		return tipoPuntoVentaService;
	}

	public void setTipoPuntoVentaService(TipoPuntoVentaService tipoPuntoVentaService) {
		this.tipoPuntoVentaService = tipoPuntoVentaService;
	}
	
	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}

	public List<PtovtaAntecipacomissao> getLsPtovtaAntecipa() {
		return lsAntecipacomissao;
	}

	public void setLsPtovtaAntecipa(List<PtovtaAntecipacomissao> lsAntecipacomissao) {
		this.lsAntecipacomissao = lsAntecipacomissao;
	}


	public List<PtovtaHorario> getLsHorario() {
		return lsHorario;
	}

	public void setLsHorario(List<PtovtaHorario> lsHorario) {
		this.lsHorario = lsHorario;
	}

	public List<TipoPuntoVenta> getLsTipoPuntoVenta() {
		return lsTipoPuntoVenta;
	}

	public void setLsTipoPuntoVenta(List<TipoPuntoVenta> lsTipoPuntoVenta) {
		this.lsTipoPuntoVenta = lsTipoPuntoVenta;
	}

	public MonedaService getMonedaService() {
		return monedaService;
	}

	public void setMonedaService(MonedaService monedaService) {
		this.monedaService = monedaService;
	}

	public List<Moneda> getLsMoneda() {
		return lsMoneda;
	}

	public void setLsMoneda(List<Moneda> lsMoneda) {
		this.lsMoneda = lsMoneda;
	}
	
	public InstiFinanceiraService getBancoService() {
		return ptovtaBancoService;
	}

	public void setBancoService(InstiFinanceiraService ptovtaBancoService) {
		this.ptovtaBancoService = ptovtaBancoService;
	}

	public List<InstiFinanceira> getLsBanco() {
		return lsBanco;
	}

	public void setLsBanco(List<InstiFinanceira> lsBanco) {
		this.lsBanco = lsBanco;
	}
	
	public Combobox getCmbBanco() {
		return cmbBanco;
	}

	public void setCmbBanco(Combobox cmbBanco) {
		this.cmbBanco = cmbBanco;
	}
	
	public Combobox getCmbPessoa() {
		return cmbPessoa;
	}

	public void setCmbPessoa(Combobox cmbPessoa) {
		this.cmbPessoa = cmbPessoa;
	}
	

	public Image getImg() {
		return img;
	}

	public void setImg(Image img) {
		this.img = img;
	}

	public Radio getRadAprobacionAutorizado() {
		return radAprobacionAutorizado;
	}

	public void setRadAprobacionAutorizado(Radio radAprobacionAutorizado) {
		this.radAprobacionAutorizado = radAprobacionAutorizado;
	}

	public Radio getRadAprobacionLatente() {
		return radAprobacionLatente;
	}

	public void setRadAprobacionLatente(Radio radAprobacionLatente) {
		this.radAprobacionLatente = radAprobacionLatente;
	}

	public Radio getRadDatosTarjetaNo() {
		return radDatosTarjetaNo;
	}

	public void setRadDatosTarjetaNo(Radio radDatosTarjetaNo) {
		this.radDatosTarjetaNo = radDatosTarjetaNo;
	}

	public Radio getRadDatosTarjetaSi() {
		return radDatosTarjetaSi;
	}

	public void setRadDatosTarjetaSi(Radio radDatosTarjetaSi) {
		this.radDatosTarjetaSi = radDatosTarjetaSi;
	}

	public MyTextbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(MyTextbox txtNome) {
		this.txtNome = txtNome;
	}
	
	public MyTextbox getTxtTitularNome() {
		return txtTitularNome;
	}

	public void setTxtTitularNome(MyTextbox txtTitularNome) {
		this.txtTitularNome = txtTitularNome;
	}

	public MyTextbox getTxtTitularCpf() {
		return txtTitularCpf;
	}

	public void setTxtTitularCpf(MyTextbox txtTitularCpf) {
		this.txtTitularCpf = txtTitularCpf;
	}

	public MyTextbox getTxtTitularRg() {
		return txtTitularRg;
	}

	public void setTxtTitularRg(MyTextbox txtTitularRg) {
		this.txtTitularRg = txtTitularRg;
	}

	public MyTextbox getTxtTitularEmissor() {
		return txtTitularEmissor;
	}

	public void setTxtTitularEmissor(MyTextbox txtTitularEmissor) {
		this.txtTitularEmissor = txtTitularEmissor;
	}

	public MyListbox getFormaPagoList() {
		return formaPagoList;
	}

	public void setFormaPagoList(MyListbox formaPagoList) {
		this.formaPagoList = formaPagoList;
	}

	public List<FormaPago> getLsFormaPago() {
		return lsFormaPago;
	}

	public void setLsFormaPago(List<FormaPago> lsFormaPago) {
		this.lsFormaPago = lsFormaPago;
	}

	public Combobox getCmbFormaPago() {
		return cmbFormaPago;
	}

	public void setCmbFormaPago(Combobox cmbFormaPago) {
		this.cmbFormaPago = cmbFormaPago;
	}

	public Doublebox getTxtCargosExtras() {
		return txtCargosExtras;
	}

	public void setTxtCargosExtras(Doublebox txtCargosExtras) {
		this.txtCargosExtras = txtCargosExtras;
	}

	public List<Nodo> getLsNodos() {
		return lsNodos;
	}

	public void setLsNodos(List<Nodo> lsNodos) {
		this.lsNodos = lsNodos;
	}

	public Button getBtnSalvarFormaPago() {
		return btnSalvarFormaPago;
	}

	public void setBtnSalvarFormaPago(Button btnSalvarFormaPago) {
		this.btnSalvarFormaPago = btnSalvarFormaPago;
	}

	public FormaPagoService getFormaPagoService() {
		return formaPagoService;
	}

	public void setFormaPagoService(FormaPagoService formaPagoService) {
		this.formaPagoService = formaPagoService;
	}

	public List<FormaPagoDet> getLsFormaPagoDet() {
		return lsFormaPagoDet;
	}

	public void setLsFormaPagoDet(List<FormaPagoDet> lsFormaPagoDet) {
		this.lsFormaPagoDet = lsFormaPagoDet;
	}

	public Combobox getCmbCiudad() {
		return cmbCiudad;
	}

	public void setCmbCiudad(Combobox cmbCiudad) {
		this.cmbCiudad = cmbCiudad;
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(Combobox cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public Combobox getCmbParada() {
		return cmbParada;
	}

	public void setCmbParada(Combobox cmbParada) {
		this.cmbParada = cmbParada;
	}

	public Combobox getCmbMoneda() {
		return cmbMoneda;
	}

	public void setCmbMoneda(Combobox cmbMoneda) {
		this.cmbMoneda = cmbMoneda;
	}

	public Combobox getCmbNodo() {
		return cmbNodo;
	}

	public void setCmbNodo(Combobox cmbNodo) {
		this.cmbNodo = cmbNodo;
	}

	public Combobox getCmbTipoPontoVenta() {
		return cmbTipoPontoVenta;
	}

	public void setCmbTipoPontoVenta(Combobox cmbTipoPontoVenta) {
		this.cmbTipoPontoVenta = cmbTipoPontoVenta;
	}

	/**
	 * @return the lsColonia
	 */
	public List<Colonia> getLsColonia() {
		return lsColonia;
	}

	/**
	 * @param lsColonia
	 *            the lsColonia to set
	 */
	public void setLsColonia(List<Colonia> lsColonia) {
		this.lsColonia = lsColonia;
	}

	/**
	 * @return the cmbColonia
	 */
	public Combobox getCmbColonia() {
		return cmbColonia;
	}

	/**
	 * @param cmbColonia
	 *            the cmbColonia to set
	 */
	public void setCmbColonia(Combobox cmbColonia) {
		this.cmbColonia = cmbColonia;
	}

	/**
	 * @return the txtCP
	 */
	public Textbox getTxtCP() {
		return txtCP;
	}

	/**
	 * @param txtCP
	 *            the txtCP to set
	 */
	public void setTxtCP(Textbox txtCP) {
		this.txtCP = txtCP;
	}
	
	public MyTextbox getTxtNumAg() {
		return txtNumAg;
	}

	public void setTxtNumAg(MyTextbox txtNumAg) {
		this.txtNumAg = txtNumAg;
	}

	
	
	public List<UsuarioBancario> getLsUsuarioBancario() {
		return lsUsuarioBancario;
	}

	public void setLsUsuarioBancario(List<UsuarioBancario> lsUsuarioBancario) {
		this.lsUsuarioBancario = lsUsuarioBancario;
	}

	public List<ParamRecoleccion> getLsParamRecoleccion() {
		return lsParamRecoleccion;
	}

	public void setLsParamRecoleccion(List<ParamRecoleccion> lsParamRecoleccion) {
		this.lsParamRecoleccion = lsParamRecoleccion;
	}
	
	

	public MyTextboxDecimal getTxtPassagemBaixa() {
		return txtPassagemBaixa;
	}

	public void setTxtPassagemBaixa(MyTextboxDecimal txtPassagemBaixa) {
		this.txtPassagemBaixa = txtPassagemBaixa;
	}

	public MyTextboxDecimal getTxtPassagemAlta() {
		return txtPassagemAlta;
	}

	public void setTxtPassagemAlta(MyTextboxDecimal txtPassagemAlta) {
		this.txtPassagemAlta = txtPassagemAlta;
	}

	public MyTextboxDecimal getTxtExcessoBaixa() {
		return txtExcessoBaixa;
	}

	public void setTxtExcessoBaixa(MyTextboxDecimal txtExcessoBaixa) {
		this.txtExcessoBaixa = txtExcessoBaixa;
	}

	public MyTextboxDecimal getTxtExcessoAlta() {
		return txtExcessoAlta;
	}

	public void setTxtExcessoAlta(MyTextboxDecimal txtExcessoAlta) {
		this.txtExcessoAlta = txtExcessoAlta;
	}

	public MyTextboxDecimal getTxtSeguroBaixa() {
		return txtSeguroBaixa;
	}

	public void setTxtSeguroBaixa(MyTextboxDecimal txtSeguroBaixa) {
		this.txtSeguroBaixa = txtSeguroBaixa;
	}

	public MyTextboxDecimal getTxtSeguroAlta() {
		return txtSeguroAlta;
	}

	public void setTxtSeguroAlta(MyTextboxDecimal txtSeguroAlta) {
		this.txtSeguroAlta = txtSeguroAlta;
	}

	public MyTextboxDecimal getTxtOutrosBaixa() {
		return txtOutrosBaixa;
	}

	public void setTxtOutrosBaixa(MyTextboxDecimal txtOutrosBaixa) {
		this.txtOutrosBaixa = txtOutrosBaixa;
	}

	public MyTextboxDecimal getTxtOutrosAlta() {
		return txtOutrosAlta;
	}

	public void setTxtOutrosAlta(MyTextboxDecimal txtOutrosAlta) {
		this.txtOutrosAlta = txtOutrosAlta;
	}

	public MyTextboxDecimal getTxtIss() {
		return txtIss;
	}

	public void setTxtIss(MyTextboxDecimal txtIss) {
		this.txtIss = txtIss;
	}

	public MyTextboxDecimal getTxtRoyaties() {
		return txtRoyaties;
	}

	public void setTxtRoyaties(MyTextboxDecimal txtRoyaties) {
		this.txtRoyaties = txtRoyaties;
	}
	
	

	public Intbox getTxtQuant() {
		return txtQuant;
	}

	public void setTxtQuant(Intbox txtQuant) {
		this.txtQuant = txtQuant;
	}

	public Intbox getTxtcodAg() {
		return txtcodAg;
	}

	public void setTxtcodAg(Intbox txtcodAg) {
		this.txtcodAg = txtcodAg;
	}
	
	
	

	public MyTextbox getTxtNumFax() {
		return txtNumFax;
	}

	public void setTxtNumFax(MyTextbox txtNumFax) {
		this.txtNumFax = txtNumFax;
	}

	public MyTextbox getTxtCompl() {
		return txtCompl;
	}

	public void setTxtCompl(MyTextbox txtCompl) {
		this.txtCompl = txtCompl;
	}

	public MyTextbox getTxtEspecie() {
		return txtEspecie;
	}

	public void setTxtEspecie(MyTextbox txtEspecie) {
		this.txtEspecie = txtEspecie;
	}

	public Textbox getTxtNomeBanco() {
		return txtNomeBanco;
	}

	public void setTxtNomeBanco(Textbox txtNomeBanco) {
		this.txtNomeBanco = txtNomeBanco;
	}

	public MyTextbox getTxtConta() {
		return txtConta;
	}

	public void setTxtConta(MyTextbox txtConta) {
		this.txtConta = txtConta;
	}

	public MyTextbox getTxtDigito() {
		return txtDigito;
	}

	public void setTxtDigito(MyTextbox txtDigito) {
		this.txtDigito = txtDigito;
	}

	public MyTextbox getTxtBilhetes() {
		return txtBilhetes;
	}

	public void setTxtBilhetes(MyTextbox txtBilhetes) {
		this.txtBilhetes = txtBilhetes;
	}

	public MyTextbox getTxtCarga() {
		return txtCarga;
	}

	public void setTxtCarga(MyTextbox txtCarga) {
		this.txtCarga = txtCarga;
	}
	
	

	public Datebox getDateAntecipData() {
		return dateAntecipData;
	}

	public void setDateAntecipData(Datebox dateAntecipData) {
		this.dateAntecipData = dateAntecipData;
	}

	public MyTextboxDecimal getTxtAntecipRetem() {
		return txtAntecipRetem;
	}

	public void setTxtAntecipRetem(MyTextboxDecimal txtAntecipRetem) {
		this.txtAntecipRetem = txtAntecipRetem;
	}

	public MyTextboxDecimal getTxtAntecipPercentual() {
		return txtAntecipPercentual;
	}

	public void setTxtAntecipPercentual(MyTextboxDecimal txtAntecipPercentual) {
		this.txtAntecipPercentual = txtAntecipPercentual;
	}

	
	public Timebox getTimeboxInicio() {
		return timeboxInicio;
	}

	public void setTimeboxInicio(Timebox timeboxInicio) {
		this.timeboxInicio = timeboxInicio;
	}

	public Timebox getTimeboxFim() {
		return timeboxFim;
	}

	public void setTimeboxFim(Timebox timeboxFim) {
		this.timeboxFim = timeboxFim;
	}

	public MyListbox getParamRecoleccionList() {
		return paramRecoleccionList;
	}

	public void setParamRecoleccionList(MyListbox paramRecoleccionList) {
		this.paramRecoleccionList = paramRecoleccionList;
	}
	
	
	public List<PtovtaEmpresa> getLsPtovtaEmpresa() {
		return lsPtovtaEmpresa;
	}

	public void setLsPtovtaEmpresa(List<PtovtaEmpresa> lsPtovtaEmpresa) {
		this.lsPtovtaEmpresa = lsPtovtaEmpresa;
	}
	
	

	public MyListbox getPtovtaEmpresaList() {
		return ptovtaEmpresaList;
	}

	public void setPtovtaEmpresaList(MyListbox ptovtaEmpresaList) {
		this.ptovtaEmpresaList = ptovtaEmpresaList;
	}

	public List<PtoVtaUsuarioBancario> getLsPtovtaUsuarioBancario() {
		return lsPtovtaUsuarioBancario;
	}

	public void setLsPtovtaUsuarioBancario(List<PtoVtaUsuarioBancario> lsPtovtaUsuarioBancario) {
		this.lsPtovtaUsuarioBancario = lsPtovtaUsuarioBancario;
	}

	public MyListbox getPtovtaUsuarioBancarioList() {
		return ptovtaUsuarioBancarioList;
	}

	public void setPtovtaUsuarioBancarioList(MyListbox ptovtaUsuarioBancarioList) {
		this.ptovtaUsuarioBancarioList = ptovtaUsuarioBancarioList;
	}
	
	
}
